      /*A *//* Head  */
/****h* path.c *********
*
*	NAME
*	  Path.c
*
*	FUNCTION
*    Finds pathes of objecs
*    Examines the path for colouring the balls
*
*	CREATION DATE
*	  1-May-1997
*
*  BUGS 
*
*
*  HISTORY
*
*    010597 started pathmarking
*
*  TODO
*
*
*  INPUTS
*
*    content of this file:
*
*    markpath()
*    comparepath()
*
*******
*/
/*E */

/*-----------------------------------------*/

      /*A *//*  External routines and Structures */

#include "define.h"

/*E */

/*-----------------------------------------*/

      /*A *//*  Global variables */

/*
   pointers to dynamically allocated memory
 */

extern struct OPTIONS options;	/* for some options */
extern int **pattern;		/* external pointer to the generated pattern */
extern int patt1;
extern int *objects;		/* used in makepattern.c */
extern int obje1;
extern int *siteswap;		/* external pointer for the decoded inputstring */
extern int site1;
extern int site2;
/*E */

/*-----------------------------------------*/

/*A */ void markpath ()
{
/****** path.c/markpath *********
*
*	NAME
*	  markpath
*
*	FUNCTION
*    This function determined different pathes and writes the
*    number of the path in the objects array objects[object][5]
*
*  SYNOPSIS
*    markpath()
*
*  RESULT
*    none
*
*  BUGS
*
*  TODO
*    multiplex
*
*  SEE ALSO
*    comparepath()
*
*******
*/
  int object;
  int path;
  int anzpathes = 0;
  int determined;
  int pathes[MAXOBJECTS];

  for (object = 0; object < options.objects; object++)
    {
      determined = FALSE;
      path = 0;
      while ((path < anzpathes) & (!determined))
	{
	  determined = comparepath (object, path, pathes);
	  path++;
	}			/* while pathes */
      if (!determined)
	{			/* make new path */
	  pathes[path] = object;
	  *(objects + (obje1 * object) + (5)) = path;	/* this is the new pathnumber */
	  anzpathes++;
	}
      else
	{			/* path can be determined */
	  *(objects + (obje1 * object) + (5)) = path - 1;	/* this is the pathnumber */
	}			/* if determined */
    }				/* objectloop */
}
/*E */

/*-----------------------------------------*/

/*A */ int 
comparepath (int object, int path, int *pathes)
{
/****** path.c/comparepath *********
*
*	NAME
*	  comparepath
*
*	FUNCTION
*    This function compares a known path with the one of the object
*
*  SYNOPSIS
*    result = comparepath(int object,int path,int *pathes)
*
*    object: the object for the test
*    path:   the number of the path
*    pathes: structure of known pathes
*
*  RESULT
*    TRUE when same path, else FALSE
*
*  BUGS
*
*  TODO
*    multiplex
*
*  SEE ALSO
*    comparepath()
*
*******
*/
  int period;			/* period to test */
  int actpos;			/* actual position */
  int startperson, starthand, startpos, startpospath, startmult;

  if (*(objects + (obje1 * object) + (7)) == *(objects + (obje1 * pathes[path]) + (7)))
    {
      /*
         now test the pathes for perfect matching
       */
      period = *(objects + (obje1 * object) + (7)) / 2;		/* /2 is because check for specific hand */
      actpos = 0;
      startperson = *(objects + (obje1 * object) + (0));
      starthand = *(objects + (obje1 * object) + (1));
      startpos = *(objects + (obje1 * object) + (2)) / 12;
      startpospath = *(objects + (obje1 * pathes[path]) + (2)) / 12;
      startmult = *(objects + (obje1 * object) + (3));
      do
	{


/*

   TODO: Multiplexloop
 */
/*
   printf("objectthere patt: %d testobjectpath %d actpos %d\n",
   pattern[actpos+startpospath][(patt1*(startperson*2+starthand))+(startmult)]+1,
   pathes[path]+1,actpos);
 */
	  if (pattern[actpos + startpospath][(patt1 * (startperson * 2 + starthand)) + (startmult)] ==
	      pathes[path])
	    {
	      /* was the pathobject at the same jugglerposition as the object ? */
//printf("no\n");
	      //printf("startmult %d",startmult);

/*
   printf("actpos %d startpos %d\n",
   *(siteswap +( site1 * ((actpos+startpospath)%options.length) ) + (site2 * startperson) + (1) ),
   *(siteswap +( site1 * ((startpos*2+starthand) % options.length) ) + (site2 * startperson) + (1) ));
 */
	      if (*siteswap + (site1 * ((actpos + startpospath) % options.length)) + (site2 * startperson) + (1) ==
		  *siteswap + (site1 * ((startpos * 2 + starthand) % options.length)) + (site2 * startperson) + (1))
		{		/* check the throwheight */
//printf("yes\n");

		  /* start of same throws found */
		  return TRUE;
		}
	    }			/* startposition */
	  actpos++;
	}
      while (actpos < period);
      return FALSE;
    }
  else
    {
      return FALSE;
    }
}
/*E */

/*-----------------------------------------*/
